#include "monWidgetGL.hpp"

#include <GL/glu.h>
#include <iostream>

monWidgetGL::monWidgetGL(QGLWidget *parent) :
    QGLWidget(parent)
{
    etat_affichage=true;
}

monWidgetGL::~monWidgetGL()
{}

void monWidgetGL::initializeGL()
{
    std::cout<<"appel monWidgetGL::initializeGL()"<<std::endl;

    glClearColor(1.0, 1.0, 1.0, 0.0);
    glEnable(GL_DEPTH_TEST);

    //mise en place de la camera
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glOrtho(-1.0f, 1.0f, -1.0f, 1.0f, -1.0f, 1.0f);
    gluPerspective(60,1.0,0.1,10.0);
    gluLookAt(0.0,0.0,2.0 , 0.0,0.0,-0.5 , 0.0,1.0,0.0);
}

void monWidgetGL::paintGL()
{
    std::cout<<"appel monWidgetGL::paintGL()"<<std::endl;

    glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();






    if(etat_affichage==true)
    {
        //****************************************//
        //definition des coordonnees
        //****************************************//
        const int nbr_sommet=3;
        float tableau_coordonees[3*nbr_sommet]={1,0,0 ,
                                                0,1,0 ,
                                                0,0,1};
        float tableau_couleur[3*nbr_sommet]={1,0,0,
                                             0,1,0,
                                             0,0,1};

        //****************************************//
        //affichage OpenGL
        //****************************************//
        glEnableClientState(GL_VERTEX_ARRAY);
        glEnableClientState(GL_COLOR_ARRAY);

        //pointeur vers coordonnees
        glVertexPointer(3,GL_FLOAT,0,&tableau_coordonees[0]);
        //pointeur vers couleurs
        glColorPointer(3,GL_FLOAT,0,&tableau_couleur[0]);
        //demande d'affichage de triangles
        glDrawArrays(GL_TRIANGLES,0,nbr_sommet);

        glDisableClientState(GL_VERTEX_ARRAY);
        glDisableClientState(GL_COLOR_ARRAY);
    }


}



void monWidgetGL::afficher()
{
    etat_affichage=!etat_affichage;

    updateGL();
}
void monWidgetGL::wireframe(bool est_actif)
{
    if(est_actif==true)
        glPolygonMode( GL_FRONT_AND_BACK, GL_LINE);
    else
        glPolygonMode( GL_FRONT_AND_BACK, GL_FILL);

    updateGL();
}
